<?php
include '../config.php';  include '../checkSession.php';
$newimg = trim($_POST['newimg']);
$newfile1 = trim($_POST['newfile1']);

$oldimg = trim($_POST['oldimg']);
$oldimg2 = trim($_POST['oldimg2']);

$lang = $_GET['lang'];
$id = $_GET['id'];
$time = time();

$enviado = $_GET['enviado'];

$archivo1 = trim($_POST['archivo']);
$imagen = trim($_POST['imagen']);
$enlace = trim($_POST['enlace']);
$texto = trim($_POST['texto']);
$titulo = trim($_POST['titulo']);
$textoDelBoton = trim($_POST['textoDelBoton']);

$imagen = $oldimg;
$file1= $oldimg2;

    if($newfile1 == 1){

        if (isset($_FILES['archivo1']) && $_FILES['archivo1']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath2 = $_FILES['archivo1']['tmp_name'];
            $fileName2 = $_FILES['archivo1']['name'];
            $fileSize2 = $_FILES['archivo1']['size'];
            $fileType2 = $_FILES['archivo1']['type'];
            $fileNameCmps2 = explode(".", $fileName2);
            $fileExtension2 = strtolower(end($fileNameCmps2));
        
            // sanitize file-name
            $newFileName2 = "ActionCard_".$time."_".$lang. '.' . $fileExtension2;
    
            // check if file has one of the following extensions
            $allowedfileExtensions2 = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'zip');
        
            if (in_array($fileExtension2, $allowedfileExtensions2))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = $aws_access_key_id;
                $aws_secret_access_key = $aws_secret_access_key;
                // Bucket
                $bucket_name = $bucket_name;
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = $aws_region;
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content2 = file_get_contents($fileTmpPath2);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                
                $content_type2 = $fileExtension;

                if($content_type2 == 'image/svg' ){ $content_type2 = "image/svg+xml";}
                if($content_type2 == 'zip' ){ $content_type2 = "application/zip";}
                if($content_type2 == 'doc' || $content_type2 == 'docx' ){ $content_type2 = "application/msword";}
                if($content_type2 == 'xls' || $content_type2 == 'xlsx' ){ $content_type2 = "application/vnd.ms-excel";}
                if($content_type2 == 'pdf' || $content_type2 == 'pdf' ){ $content_type2 = "application/pdf";}
                // Name of content on S3
                $content_title2 = 'docs/estadisticas-informacion/'.$lang.'/'.$newFileName2;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type2;
                $request_headers['Content-Disposition'] = 'inline';
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content2);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title2;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content2);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title2;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content2);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $file1 = $content_title2;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de archivo no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de archivo:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['imagen']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }


    $curl = curl_init();

    if($lang == "en"){

        curl_setopt_array($curl, array(
            CURLOPT_URL => $endpoint_graph_cms,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',

            CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  updateActionCardEstadisticas(data: {texto: \\"'.$texto.'\\", textoDelBoton: \\"'.$textoDelBoton.'\\", titulo: \\"'.$titulo.'\\", enviadoRevision: \\"'.$enviado.'\\", archivo: \\"'.$file1.'\\", enlace: \\"'.$enlace.'\\"}, where: {id: \\"'.$id.'\\"})  {\\r\\n     id\\r\\n   }\\r\\n \\r\\n \\r\\n}\\r\\n","variables":{}}',
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/json',
              'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
            ),
          ));

    }

    if($lang == "es"){
        curl_setopt_array($curl, array(
            CURLOPT_URL => $endpoint_graph_cms,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  updateActionCardEstadisticas(where: {id: \\"'.$id.'\\"}, data: {localizations: {update: {data: {archivo: \\"'.$file1.'\\",  enlace: \\"'.$enlace.'\\", textoDelBoton: \\"'.$textoDelBoton.'\\", enviadoRevision: \\"'.$enviado.'\\", texto: \\"'.$texto.'\\", titulo: \\"'.$titulo.'\\"}, locale: es_MX}}}) {\\r\\n    id\\r\\n  }\\r\\n \\r\\n}\\r\\n","variables":{}}',
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/json',
              'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
            ),
          ));

    }

    $response = curl_exec($curl);
    curl_close($curl);
    //echo $response;

    $jsonrespuesta = json_decode($response, true);
    $id = $jsonrespuesta['data']['updateActionCardEstadisticas']['id'];

//echo $id;

  $sucess = "<p class='successmsg' style='text-transform:Capitalize;'>".$tipo." actualizado correctamente</p>";
  $fail = "<p class='errormsg'>Falló la actualización..</p> ";


if(strlen($id)>10){

    echo $sucess;

    $string = $newstatus;
    $string = '"'.$string.'"';
    echo '<script>
        
        setTimeout(() => {
            $(".popUpEnlace").fadeOut();
        }, 1500);
    </script>';
}

else{
    echo $fail;
}

?>